UNIT MATHPACK; {Mathematical Function Library}

{2R1a- MC 1995 MAR 22 WED - recovered from tape backup; source was all binary-zeroes}
{2R1 - MC 1995 JAN 20 FRI - random #s within specified range}
{1R1 - MC 1993 APR 29 THU - exponentiation & rooting}

INTERFACE

USES
  SYSREALU;

{Exponentials & Roots}

FUNCTION ROOT   (X,Y : SYSREAL) : SYSREAL;
FUNCTION POWER  (X,Y : SYSREAL) : SYSREAL;

FUNCTION IROOT  (X,Y : LONGINT) : SYSREAL;
FUNCTION IPOWER (X,Y : LONGINT) : LONGINT;

{Random Numbers}

FUNCTION RANDINT (RMIN,RMAX : LONGINT) : LONGINT;

IMPLEMENTATION

FUNCTION POWER (X,Y : SYSREAL) : SYSREAL;
BEGIN
  POWER := EXP(LN(X)*Y);
END;

FUNCTION ROOT (X,Y : SYSREAL) : SYSREAL;
BEGIN
  ROOT := EXP(LN(X)/Y);
END;

FUNCTION IPOWER (X,Y : LONGINT) : LONGINT;
VAR
  K,P : LONGINT;
BEGIN
  IF (Y = 0)
    THEN IPOWER := 1
  ELSE IF (Y = 1)
    THEN IPOWER := X
  ELSE IF (Y < 0)
    THEN IPOWER := 0
  ELSE BEGIN
    P := X;
    FOR K := 2 TO Y DO
      P := P * X;
    IPOWER := P;
  END;
END;

FUNCTION IROOT (X,Y : LONGINT) : SYSREAL;
VAR
  A,B : SYSREAL;
BEGIN
  A := X;
  B := Y;
  IROOT := EXP(LN(A)/B);
END;

FUNCTION RANDINT (RMIN,RMAX : LONGINT) : LONGINT;
BEGIN
  RANDINT := (RANDOM(SUCC(RMAX-RMIN))+RMIN);
END;

END.
